// NFA,FWA - Notification templates related components and methods

OPMClient.NotificationTemplateConfigComponent = Ember.Component.extend({
	templateName:"notification-template-config", //NO I18N
	didInsertElement:function() {
	},
	subjectVariableChanged:function() {
		var selectedVariable = this.get("model.selectedSubjectVariable"); //NO I18N
		if(selectedVariable===null || selectedVariable===undefined || selectedVariable==="" || selectedVariable==="default") { //NO I18N
			this.set("model.subjectVariable",nt_getDefaultSubjectVariables()); //NO I18N
		}else {
			this.set("model.subjectVariable",this.model.subjectVariable+" "+selectedVariable); //NO I18N
		}
	}.observes("model.selectedSubjectVariable"), //NO I18N
	messageVariableChanged:function() {
		var delimiter = (this.model.type==="RunProgram")?" ":" \n"; //NO I18N
		var selectedVariable = this.get("model.selectedMessageVariable"); //NO I18N
		if(selectedVariable===null || selectedVariable===undefined || selectedVariable==="" || selectedVariable==="default") { //NO I18N
			this.set("model.messageVariable",nt_getDefaultMessageVariables()); //NO I18N
		}else {
			this.set("model.messageVariable",this.model.messageVariable+delimiter+selectedVariable); //NO I18N
		}
	}.observes("model.selectedMessageVariable"), //NO I18N
	actions:{
		showTemplateTypeList:function() {
			if($(".notifyProfileType1 .titleDropDown").hasClass("active")){//No I18N
				$(".notifyProfileType1 .titleDropDown").removeClass("active");//No I18N
			}else{
				$(".notifyProfileType1 .titleDropDown").addClass("active");//No I18N
			}
		},
		showTemplateTypes:function() {
			nt_redirectToNotificationTemplateTypes();
		},
		addTemplate:function(type) {
			if(type!==this.model.type) {
				nt_redirectToNotificationTemplateTask(type,"Add","New"); //NO I18N
			}
		},
		saveTemplate:function(isTesting) {
			var model = jQuery.extend(true,{},this.model); //NO I18N
			if(validateNotificationTemplate(model)) {
				saveNotificationTemplate(model,isTesting);
			}
		},
		cancelAction:function() {
			nt_redirectToNotificationTemplateList();
		},
		goBackAction:function() {
			window.history.back();
		}
	},
	willDestroyElement:function(){
		$("#"+this.elementId).find("*").remove(); //NO I18N
	}
});

OPMClient.EmailTemplateConfigComponent = Ember.Component.extend({
	templateName:"email-template-config", //NO I18N
	initDefaults:function() {
		if(window.isserver) {
			OPMClient.SettingsAddEditController.set("isMailServerConfigured",false); //NO I18N
		}
		if(!OPMClient.SettingsAddEditController.isMailServerConfigured) {
			var response = opm_ajaxGetResponse(window.OPM.apiUrlPattern+"/admin/GetMailServerSettings"); //NO I18N
			if(response!==undefined && response.primary!==undefined) {
				OPMClient.SettingsAddEditController.set("mailServerSettings",response); //NO I18N
				OPMClient.SettingsAddEditController.set("isMailServerConfigured",true); //NO I18N
			}
		}
		if(!this.isEmailSMS) {
			this.set("mailFormatList",[ //NO I18N
				{name:Ember.I18n.t("webclient.admin.profiledetails.plainText"),	value:"PLAIN"}, //NO I18N
				{name:Ember.I18n.t("webclient.admin.profiledetails.html"),		value:"HTML"}, //NO I18N
				{name:Ember.I18n.t("webclient.admin.profiledetails.both"),		value:"BOTH"} //NO I18N
			]);
			if(this.model.mailFormat===undefined) {
				this.set("model.mailFormat",(this.model.mailFormat || "BOTH")); //NO I18N
			}else {
				this.getMailFormatList();
			}
		}
	}.on("init"), //NO I18N
	didInsertElement:function() {
		if(OPMClient.SettingsAddEditController.isMailServerConfigured && this.model.task==="Add") { //NO I18N
			this.set("model.fromAddress",OPMClient.SettingsAddEditController.mailServerSettings.primary.fromemailid); //NO I18N
			this.set("model.toAddress",OPMClient.SettingsAddEditController.mailServerSettings.primary.emailid); //NO I18N
		}
		this.set("model.hideEmailCCLink",(this.model.ccAddress===undefined)); //NO I18N
	},
	getMailFormatList:function() {
		var mailFormatList = jQuery.extend(true,[],this.mailFormatList);
		for(var i=0;i<mailFormatList.length;i++){
			mailFormatList[i].checked = (this.model.mailFormat===mailFormatList[i].value)?"checked":""; //NO I18N
		}
		this.set("mailFormatList",mailFormatList); //NO I18N
	}.observes("model.mailFormat"), //NO I18N
	actions:{
		mailFormatChanged:function(value) {
			this.set("model.mailFormat",value); //NO I18N
		},
		configMailServer:function() {
			var callBckURL = nt_getTemplateTaskCallBackURL(this.model.type,this.model.task,this.model.templateID);
			var loadingMsg = Ember.I18n.t("webclient.admin.mailserver.message")+" "+Ember.I18n.t("opu.common.PLEASE_CONFIGURE"); //NO I18N
			isMailServerConfigured(callBckURL,loadingMsg);
		},
		showHideCCLink:function() {
			this.set("model.hideEmailCCLink",!this.model.hideEmailCCLink); //NO I18N
		}
	},
	willDestroyElement:function(){
		$("#"+this.elementId).find("*").remove(); //NO I18N
	}
});

OPMClient.SMSTemplateConfigComponent = Ember.Component.extend({
	templateName:"smsTemplateConfig", //NO I18N
	showSMSConfigMsg:false,
	initDefaults:function() {
		var selectedGateWay = "Clickatell"; //NO I18N
		var smsGatewaysVsID = {serialmodem:1,Custom:5,SMPP:6};
		if(this.model.smsGatewayConfig===undefined) {
			var smsObj = opm_ajaxGetResponse(window.OPM.apiUrlPattern+"/admin/getSMSGatewayConfiguration"); //NO I18N
			smsObj.SMPP=smsObj.smpp; delete smsObj.smpp;
			smsObj.Custom=smsObj.custom; delete smsObj.custom;
			for(key in smsObj) {
				if(smsObj[key]==="true") { //NO I18N
					selectedGateWay = key;
					break;
				}
			}
			this.set("model.smsGatewayConfig",smsObj); //NO I18N
		}

		if(this.model.smsGateways===undefined) {
			var smsGateways = [];
			if(smsObj.serialmodem==="true") { //NO I18N
				smsGateways.push({group:"",name:Ember.I18n.t("webclient.sms.type.serial.modem"),value:"serialmodem"}); //NO I18N
			}
			smsGateways.push({group:"",name:Ember.I18n.t("webclient.sms.smpp"),value:"SMPP"}); //NO I18N

			var inBuiltSMSGateways = opm_ajaxGetResponse(window.OPM.apiUrlPattern+"/admin/getInBuiltSMSGateways"); //NO I18N

			for(var i=0;i<inBuiltSMSGateways.length;i++) {
				smsGateways.push({group:Ember.I18n.t("webclient.sms.customsms"),name:inBuiltSMSGateways[i].gatewayName,value:inBuiltSMSGateways[i].gatewayName}); //NO I18N
				smsGatewaysVsID[inBuiltSMSGateways[i].gatewayName]=inBuiltSMSGateways[i].gatewayId;
			}
			smsGateways.push({group:Ember.I18n.t("webclient.sms.customsms"),name:Ember.I18n.t("nfa.common.custom"),value:"Custom"}); //NO I18N
			this.set("model.smsGateways",smsGateways); //NO I18N
		}
		if(this.model.selectedGateWay===undefined){
			this.set("model.selectedGateWay",selectedGateWay); //NO I18N
		}
		this.set("model.smsGatewaysVsID",smsGatewaysVsID); //NO I18N

		if(this.model.task==="Add") { //NO I18N
			this.set("model.messageVariable","$message"); //NO I18N
		}
	}.on("init"), //NO I18N
	didInsertElement:function() {
	},
	smsGatewayChanged:function() {
		if(this.model.smsGatewayConfig!==undefined) {
			this.set("showSMSConfigMsg",(this.model.smsGatewayConfig[this.model.selectedGateWay]==="false")); //NO I18N
		}
	}.observes("model.selectedGateWay"), //NO I18N
	actions:{
		configSMSServer:function(flag) {
			opmGlobalRoute.transitionTo("Settings.Basic.SMS"); //NO I18N
		}
	},
	willDestroyElement:function(){
		$("#"+this.elementId).find("*").remove(); //NO I18N
	}
});

OPMClient.ChatTemplateConfigComponent = Ember.Component.extend({
	templateName:"chat-template-config", //NO I18N
	channelPrompt:Ember.I18n.t("webclient.slack.channel.select"), //NO I18N
	memberPrompt:Ember.I18n.t("webclient.slack.member.select"), //NO I18N
	hideSlackConfigLink:false,
	userImageOptions:{
		templateResult:function(state) {
			if (!state.id) {return state.text;}
			var $state = $("<span class='slack-image'><img src='"+state.id.split("_#_")[1]+"'/><span>"+state.text+"</span></span>"); //NO I18N
			return $state;
		}
	},
	initDefaults:function() {
		this.set("receiverTypeList",[ //NO I18N
			{name:Ember.I18n.t("webclient.slack.channel"),	value:"channel"}, //NO I18N
			{name:Ember.I18n.t("webclient.slack.member"),	value:"user"} //NO I18N
		]);
		if(this.model.receiverType===undefined) {
			this.set("model.receiverType","channel"); //NO I18N
		}else {
			this.getReceiverTypeList();
		}
		var jsonData = opm_ajaxGetResponse(window.OPM.apiUrlPattern+"/admin/checkForAddon?AddOn=Chat"); //NO I18N
		this.set("hideSlackConfigLink",jsonData.SLACK_ENABLED); //NO I18N
		this.getSlackDetails();
	}.on("init"), //NO I18N
	didInsertElement:function() {
	},
	getReceiverTypeList:function() {
		this.set("receiverTypeList",nfa_getCheckedList(jQuery.extend(true,[],this.receiverTypeList),"value",this.model.receiverType)); //NO I18N
	}.observes("model.receiverType"), //NO I18N
	getSlackChannels:function(profileDetails) {
		if(this.model.slackChannelList===undefined) {
			var jsonData = opm_ajaxGetResponse(window.OPM.apiUrlPattern+"/admin/getSlackChannels"); //NO I18N
			if(jsonData.error!==undefined){
				showMessage(jsonData);
			}else{
				this.set("model.slackChannelList",jsonData); //NO I18N
			}
		}
	},
	getSlackUsers:function(profileDetails) {
		if(this.model.slackUserList===undefined) {
			var jsonData = opm_ajaxGetResponse(window.OPM.apiUrlPattern+"/admin/getSlackUsers"); //NO I18N
			if(jsonData.error!==undefined){
				showMessage(jsonData);
			}else {
				var userIndex=0;
				for(var i=0;i<jsonData.length;i++) {
					if(jsonData[i].id===this.model.slackMemberID) {
						userIndex=i;
					}
					jsonData[i].id=jsonData[i].id+"_#_"+jsonData[i].image; //NO I18N
				}
				this.set("model.slackUserList",jsonData); //NO I18N
				this.set("model.slackUserID",jsonData[userIndex].id); //NO I18N
			}
		}
	},
	slackUserChanged:function() {
		if(this.model.slackUserID!==undefined && this.model.slackUserID!==null) {
			this.set("model.slackMemberID",this.model.slackUserID.split("_")[0]); //NO I18N
		}
	}.observes("model.slackUserID"), //NO I18N
	getSlackDetails:function() {
		if(this.hideSlackConfigLink) {
			if(this.model.receiverType==="channel") { //NO I18N
				this.getSlackChannels();
			}else {
				this.getSlackUsers();
			}
		}
	},
	actions:{
		slackSendToChange:function(receiverType) {
			if(this.model.receiverType!==receiverType) {
				this.set("model.receiverType",receiverType); //NO I18N
				this.getSlackDetails();
			}
		}
	},
	willDestroyElement:function(){
		$("#"+this.elementId).find("*").remove(); //NO I18N
	}
});

OPMClient.RunProgramTemplateConfigComponent = Ember.Component.extend({
	templateName:"run-program-template-config", //NO I18N
	initDefaults:function() {
		if(this.model.task==="Add") { //NO I18N
			this.set("model.messageVariable",""); //NO I18N
			this.set("model.errappend",false); //NO I18N
			this.set("model.append",false); //NO I18N
		}
		this.set("model.msgVariablePrompt",Ember.I18n.t("webclient.admin.profiledetails.ArgumentVariable")); //NO I18N
	}.on("init"), //NO I18N
	didInsertElement:function() {	
	},
	willDestroyElement:function(){
		$("#"+this.elementId).find("*").remove(); //NO I18N
	}
});


OPMClient.LogTicketTemplateConfigComponent = Ember.Component.extend({
	templateName:"log-ticket-template-config", //NO I18N
	initDefaults:function() {
		var serviceList = [
			{name:Ember.I18n.t("webclient.home.servicedesk"),	value:"serviceDesk",className:"active"}, //NO I18N
			{name:Ember.I18n.t("webclient.servicenow.title"),	value:"serviceNow",	className:""} //NO I18N
		];
		this.set("serviceList",serviceList); //NO I18N
		this.set("model.serviceDeskLists",{}); //NO I18N
		if(this.model.serviceNowLists===undefined) {
			this.set("model.serviceNowLists",{}); //NO I18N
		}
		this.set("model.selectPrompt",{name:Ember.I18n.t("webclient.map.flash.chooseAValue"),value:((this.model.serviceType==="serviceDesk")?"none":"")}); //NO I18N
		var response = opm_ajaxGetResponse(window.OPM.apiUrlPattern+"/admin/checkForAddon?AddOn=helpDesk"); //NO I18N
		this.set("model.serviceDeskEnabled",response.serviceDeskEnabled); //NO I18N
		this.set("model.serviceNowEnabled",response.serviceNowEnabled); //NO I18N
		this.send("serviceTypeChanged",(this.model.serviceType || "serviceDesk")); //NO I18N
	}.on("init"), //NO I18N
	didInsertElement:function() {
	},
	actions:{
		serviceTypeChanged:function(type,className) {
			if(className!=="active") { //NO I18N
				this.set("model.serviceType",type); //NO I18N
				var list = jQuery.extend(true,[],this.serviceList);
				for(var i=0;i<list.length;i++) {
					list[i].className = (list[i].value===type)?"active":""; //NO I18N
				}
				this.set("serviceList",list); //NO I18N

			}
		}
	},
	willDestroyElement:function(){
		$("#"+this.elementId).find("*").remove(); //NO I18N
	}
});

OPMClient.ServiceDeskTemplateConfigComponent = Ember.Component.extend({
	templateName:"service-desk-template-config", //NO I18N
	didInsertElement:function() {
		if(this.model.serviceDeskEnabled) {
			this.getDefaultTicketValues(false);
		}
	},
	getDefaultTicketValues:function(isRefresh) {
		if(this.lists.categoryList===undefined || isRefresh) {
			var apiURL = window.OPM.apiUrlPattern+"/admin/getDefaultLogaTicketValues"; //NO I18N
			var callBckFunc = function(jsonData,self){
				if(jsonData.error===undefined){
					self.set("showErrorMsg",false); //NO I18N
					self.set("lists.categoryList",jsonData.categoryList); //NO I18N
					self.set("lists.priorityList",jsonData.priorityList); //NO I18N
					self.set("lists.groupList",jsonData.grpTechList); //NO I18N
					self.updateDefaultTicketValues();
				}else {
					self.set("showErrorMsg",true); //NO I18N
					nfa_infoMsgs(jsonData);
					delete self.lists.categoryList;
					delete self.lists.priorityList;
					delete self.lists.groupList;
				}
			};
			nfa_getAjaxResponseWithAsync(apiURL,{},callBckFunc,this,Ember.I18n.t("webclient.sdp.getticketmsg")); //NO I18N
		}else {
			this.updateDefaultTicketValues();
		}
	},
	updateDefaultTicketValues:function() {
		if(!this.showErrorMsg) {
			this.set("categoryList",jQuery.extend(true,[],this.lists.categoryList)); //NO I18N
			this.set("priorityList",jQuery.extend(true,[],this.lists.priorityList)); //NO I18N
			this.set("groupList",jQuery.extend(true,[],this.lists.groupList)); //NO I18N
		}
	},
	getTicketSubcategory:function() {
		if(this.ticketCategoryID!==""){ //NO I18N
			var apiURL = window.OPM.apiUrlPattern+"/admin/getLogaTicketSubcategory"; //NO I18N
			var callBckFunc = function(jsonData,self){
				if(jsonData.error===undefined){
					self.set("subCategoryList",jsonData); //NO I18N
				}else {
					self.set("subCategoryList",[]); //NO I18N
					self.set("ticket.ticketSubCategory",""); //NO I18N
					self.set("ticketSubCategoryID",""); //NO I18N
					nfa_infoMsgs(jsonData);
				}
			};
			nfa_getAjaxResponseWithAsync(apiURL,{categoryID:this.ticketCategoryID},callBckFunc,this,Ember.I18n.t("webclient.sdp.getSubCatmsg")); //NO I18N
		}
	}.observes("ticketCategoryID"), //NO I18N
	getTicketItems:function(subCategoryID) {
		if(this.ticketSubCategoryID!=="") { //NO I18N
			var apiURL = window.OPM.apiUrlPattern+"/admin/getLogaTicketItems"; //NO I18N
			var callBckFunc = function(jsonData,self){
				if(jsonData.error===undefined){
					self.set("ticketItemList",jsonData); //NO I18N
				}else {
					self.set("ticketItemList",[]); //NO I18N
					self.set("ticket.ticketItem",""); //NO I18N
					self.set("ticketItemID",""); //NO I18N
					nfa_infoMsgs(jsonData);
				}
			};
			nfa_getAjaxResponseWithAsync(apiURL,{subCategoryID:this.ticketSubCategoryID},callBckFunc,this,Ember.I18n.t("webclient.sdp.getItemsmsg")); //NO I18N
		}
	}.observes("ticketSubCategoryID"), //NO I18N
	getTicketTechnicians:function(groupID) {
		if(this.ticketGroupID!=="") {
			var apiURL = window.OPM.apiUrlPattern+"/admin/getLogaTicketTechnicians"; //NO I18N
			var callBckFunc = function(jsonData,self){
				if(jsonData.error===undefined){
					self.set("technicianList",jsonData); //NO I18N
				}else {
					self.set("technicianList",[]); //NO I18N
					self.set("ticket.ticketTechnician",""); //NO I18N
					self.set("ticketTechnicianID",""); //NO I18N
					nfa_infoMsgs(jsonData);
				}
			};
			nfa_getAjaxResponseWithAsync(apiURL,{groupID:this.ticketGroupID},callBckFunc,this,Ember.I18n.t("webclient.sdp.getticketmsg")); //NO I18N
		}
	}.observes("ticketGroupID"), //NO I18N
	actions:{
		refreshServiceDesk:function() {
			var apiURL = window.OPM.apiUrlPattern+"/admin/refreshSDPTicketFields"; //NO I18N
			var callBckFunc = function(jsonData,self){
				if(jsonData!==undefined) {
					self.getDefaultTicketValues(true);
				}
			};
			nfa_getAjaxResponseWithAsync(apiURL,"",callBckFunc,this,Ember.I18n.t("webclient.sdp.refreshmsg",{param0:window.OPM.productName})); //NO I18N
		}
	},
	willDestroyElement:function(){
		$("#"+this.elementId).find("*").remove(); //NO I18N
	}
});

OPMClient.ServiceNowTemplateConfigComponent = Ember.Component.extend({
	templateName:"service-now-template-config", //NO I18N
	ticketPrompt:Ember.I18n.t("webclient.map.flash.chooseAValue"), //NO I18N
	initDefaults:function() {
	// 	this.set("itemOptions",{ //NO I18N
	// 		ajax: {
	// 			url:window.OPM.apiUrlPattern+"/admin/getServiceNowDefaultLogaTicketValues?fieldName=items", //NO I18N
	// 			dataType:"json", //NO I18N
	// 			delay: 250,
	// 			data:function(params) {
	// 				return {
	// 					searchTerm:params.term,
	// 					offset:params.offset
	// 				};
	// 			},
	// 			processResults:function(data,params) {
	// 				params.offset = data.offset || 50;
	// 				return {
	// 					results: data.results,
	// 					pagination: {
	// 						more:data.pagination.more
	// 					}
	// 				};
	// 			},
	// 			cache:true
	// 		},
	// 		minimumInputLength:1
	// 	});
	// 	if(this.model.itemName!==undefined) {
	// 		this.set("ticketItemList",[{name:this.model.itemName,sys_id:this.ticket.ticketItem}]); //NO I18N
	// 	}
		
		if(this.model.task==="Add") { //NO I18N
			this.set("ticket.ticketItem",""); //NO I18N
		}
		
	}.on("init"), //NO I18N
	didInsertElement:function() {
		if(this.model.serviceNowEnabled) {
			this.getDefaultTicketValues();
		}
	},
	getDefaultTicketValues:function() {
		if(this.lists.categoryList===undefined) {
			var apiURL = window.OPM.apiUrlPattern+"/admin/getServiceNowDefaultLogaTicketValues"; //NO I18N
			var callBckFunc = function(jsonData,self){
				if(jsonData.error===undefined){
					self.set("showErrorMsg",false); //NO I18N
					self.set("lists.categoryList",jsonData.result.categoryDetails); //NO I18N
					self.set("lists.priorityList",jsonData.result.priorityDetails); //NO I18N
					self.set("lists.groupList",jsonData.result.groupDetails); //NO I18N
					self.updateDefaultTicketValues();
				}else {
					self.set("showErrorMsg",true); //NO I18N
					nfa_infoMsgs(jsonData);
					delete self.lists.categoryList;
					delete self.lists.priorityList;
					delete self.lists.groupList;
				}
			};
			nfa_getAjaxResponseWithAsync(apiURL,{fieldName:"others"},callBckFunc,this,Ember.I18n.t("webclient.servicenow.getticketmsg")); //NO I18N
		}else {
			this.updateDefaultTicketValues();
		}
	},
	updateDefaultTicketValues:function() {
		if(!this.showErrorMsg) {
			this.set("categoryList",jQuery.extend(true,[],this.lists.categoryList)); //NO I18N
			this.set("priorityList",jQuery.extend(true,[],this.lists.priorityList)); //NO I18N
			this.set("groupList",jQuery.extend(true,[],this.lists.groupList)); //NO I18N
		}
	},
	getTicketSubcategory:function() {
		if(this.ticketCategoryID!==""){ //NO I18N
			var apiURL = window.OPM.apiUrlPattern+"/admin/getServiceNowLogaTicketSubcategory"; //NO I18N
			var callBckFunc = function(jsonData,self){
				if(jsonData.error===undefined){
					self.set("subCategoryList",jsonData); //NO I18N
				}else {
					self.set("subCategoryList",[]); //NO I18N
					self.set("ticket.ticketSubCategory",""); //NO I18N
					self.set("ticketSubCategoryID",""); //NO I18N
					nfa_infoMsgs(jsonData);
				}
			};
			nfa_getAjaxResponseWithAsync(apiURL,{categoryID:this.ticketCategoryID},callBckFunc,this,Ember.I18n.t("webclient.servicenow.getsubgrpmsg")); //NO I18N
		}
	}.observes("ticketCategoryID"), //NO I18N
	getTicketTechnicians:function(groupID) {
		if(this.ticketGroupID!=="") {
			var apiURL = window.OPM.apiUrlPattern+"/admin/getServiceNowLogaTicketTechnicians"; //NO I18N
			var callBckFunc = function(jsonData,self){
				if(jsonData.error===undefined){
					self.set("technicianList",jsonData); //NO I18N
				}else {
					self.set("technicianList",[]); //NO I18N
					self.set("ticket.ticketTechnician",""); //NO I18N
					self.set("ticketTechnicianID",""); //NO I18N
					nfa_infoMsgs(jsonData);
				}
			};
			nfa_getAjaxResponseWithAsync(apiURL,{groupID:this.ticketGroupID},callBckFunc,this,Ember.I18n.t("webclient.servicenow.gettechnicianmsg")); //NO I18N
		}
	}.observes("ticketGroupID"), //NO I18N
	willDestroyElement:function(){
		$("#"+this.elementId).find("*").remove(); //NO I18N
	}
});

OPMClient.WebAlarmTemplateConfigComponent = Ember.Component.extend({
	templateName:"web-alarm-template-config", //NO I18N
	showSoundUpload:false,
	adminSearchOption:false,
	operatorSearchOption:false,
	guestSearchOption:false,
	initDefaults:function() {
		var operatorOptionList = [{name:Ember.I18n.t("webclient.admin.users.allusers"),value:"-2"},{name:Ember.I18n.t("webclient.np.webalarm.selectedUsers"),value:"listAll"}]; //NO I18N
		var containerClass = "webAlarmsNotification"; //NO I18N
		if(window.OPM.isAuthorized) {
			containerClass+=" twoColumn"; //NO I18N
			this.set("adminOptionList",[{name:Ember.I18n.t("webclient.admin.users.allusers"),value:"-1"},{name:Ember.I18n.t("webclient.np.webalarm.selectedUsers"),value:"listAll"}]); //NO I18N
			if(this.model.adminOption==undefined) {
				this.set("model.adminOption","listAll"); //NO I18N
			}
		}else {
			operatorOptionList.splice(0,1);
		}

		this.set("operatorOptionList",operatorOptionList); //NO I18N
		if(this.model.operatorOption==undefined) {
			this.set("model.operatorOption","listAll"); //NO I18N
		}

		if(window.OPM.isNFA) {
			this.set("guestOptionList",[{name:Ember.I18n.t("webclient.admin.users.allusers"),value:"-3"},{name:Ember.I18n.t("webclient.np.webalarm.selectedUsers"),value:"listAll"}]); //NO I18N
			if(this.model.guestOption==undefined) {
				this.set("model.guestOption","listAll"); //NO I18N
			}
			containerClass += (window.OPM.isAuthorized)?" threeColumn":" twoColumn"; //NO I18N
		}
		this.set("containerClass",containerClass); //NO I18N

		if(this.model.selectedUsers===undefined) {
			this.set("model.selectedUsers",[]); //NO I18N
		}

		if(this.model.webAlarmUserList===undefined) {
			var userList = opm_ajaxGetResponse(window.OPM.apiUrlPattern+"/admin/listWebAlarmUsers"); //NO I18N
			var counter=0;
			for(var i=0;i<userList.Operator.length;i++) {
				userList.Operator[i].isSelected = this.model.selectedUsers.contains(userList.Operator[i].USERID); //NO I18N
				if(userList.Operator[i].isSelected){counter++;}
			}

			this.set("selectedOperator",counter); //NO I18N
			this.set("allOperatorSelected",(userList.Operator.length!=0 && userList.Operator.length==counter)); //NO I18N
			this.set("operatorSearchOption",userList.Operator.length>5); //NO I18N

			if(window.OPM.isAuthorized) {
				counter=0;
				for(var i=0;i<userList.Administrator.length;i++) {
					userList.Administrator[i].isSelected = this.model.selectedUsers.contains(userList.Administrator[i].USERID); //NO I18N
					if(userList.Administrator[i].isSelected){counter++;}
				}
				this.set("selectedAdministrator",counter); //NO I18N
				this.set("allAdministratorSelected",(userList.Administrator.length!=0 && userList.Administrator.length==counter)); //NO I18N
				this.set("adminSearchOption",(userList.Administrator.length>5)); //NO I18N
			}

			if(window.OPM.isNFA) {
				counter=0;
				for(var i=0;i<userList.Guest.length;i++) {
					userList.Guest[i].isSelected = this.model.selectedUsers.contains(userList.Guest[i].USERID); //NO I18N
					if(userList.Guest[i].isSelected){counter++;}
				}
				this.set("selectedGuest",counter); //NO I18N
				this.set("allGuestSelected",(userList.Guest.length!=0 && userList.Guest.length==counter)); //NO I18N
				this.set("guestSearchOption",userList.Guest.length>5); //NO I18N
			}
			this.set("model.webAlarmUserList",userList); //NO I18N
		}
		if(this.model.webAlarmSoundList===undefined) {
			var soundList = opm_ajaxGetResponse(window.OPM.apiUrlPattern+"/admin/getWebAlarmSoundFiles"); //NO I18N
			this.set("model.webAlarmSoundList",soundList); //NO I18N
		}
	}.on("init"), //NO I18N
	selectAllAdmin:function() {
		if(this.model.adminOption!==undefined && this.model.adminOption!=="listAll") { //NO I18N
			this.send("selectAllChanged","Administrator",true); //NO I18N
		}
	}.observes("model.adminOption"), //NO I18N
	selectAllOperator:function() {
		if(this.model.operatorOption!==undefined && this.model.operatorOption!=="listAll") { //NO I18N
			this.send("selectAllChanged","Operator",true); //NO I18N
		}
	}.observes("model.operatorOption"), //NO I18N
	selectAllGuest:function() {
		if(this.model.guestOption!==undefined && this.model.guestOption!=="listAll") { //NO I18N
			this.send("selectAllChanged","Guest",true); //NO I18N
		}
	}.observes("model.guestOption"), //NO I18N
	actions:{
		showHideSoundUploadDiv:function(flag) {
			this.set("showSoundUpload",flag); //NO I18N
		},
		playSound:function() {
			var ping = new Audio(this.model.selectedAlarmSound);
			ping.play();
		},
		selectAllChanged:function(userRole,isSelected) {
			var userList = jQuery.extend(true,[],this.model.webAlarmUserList);
			var selectedUsers = jQuery.extend(true,[],this.model.selectedUsers);
			for(var i=0;i<userList[userRole].length;i++) {
				if(isSelected) {
					if(userList[userRole][i].isSelected) {
						selectedUsers = removeArrayByValue(selectedUsers,userList[userRole][i].USERID);
					}
				}else if(!userList[userRole][i].isSelected) {
					selectedUsers.push(userList[userRole][i].USERID);
				}
				userList[userRole][i].isSelected = !isSelected;
			}
			this.set("model.selectedUsers",selectedUsers); //NO I18N
			this.set("all"+userRole+"Selected",!isSelected); //NO I18N
			this.set("selected"+userRole,(isSelected)?0:userList[userRole].length); //NO I18N
			this.set("model.webAlarmUserList",userList); //NO I18N
		},
		userSelectionChanged:function(userRole,userID,isSelected) {
			var userList = jQuery.extend(true,[],this.model.webAlarmUserList);
			if(isSelected) {
				this.set("model.selectedUsers",removeArrayByValue(this.model.selectedUsers,userID)); //NO I18N
				this.set("selected"+userRole,this["selected"+userRole]-1); //NO I18N
				this.set("all"+userRole+"Selected",!isSelected); //NO I18N
			}else {
				var selectedUsers = jQuery.extend(true,[],this.model.selectedUsers);
				selectedUsers.push(userID);
				this.set("model.selectedUsers",selectedUsers); //NO I18N
				this.set("selected"+userRole,this["selected"+userRole]+1); //NO I18N
				this.set("all"+userRole+"Selected",(userList[userRole].length==this["selected"+userRole])); //NO I18N
			}
			for(var i=0;i<userList[userRole].length;i++) {
				if(userList[userRole][i].USERID===userID) {
					userList[userRole][i].isSelected = !isSelected;
					break;
				}
			}
			this.set("model.webAlarmUserList",userList); //NO I18N
		},
		addNewSoundFile: function () {
			if(!opm_validateFields({"empty":["webAlarmSoundFile"]})) { //NO I18N
				return;
			}
			var fileObject = $("#webAlarmSoundFile")[0].files[0]; //NO I18N
			var fileParts = $("#webAlarmSoundFile").val().split("."); //NO I18N
			var fileExtension =fileParts[fileParts.length-1]; //NO I18N

			if(fileObject===undefined || fileExtension!=="mp3") { //NO I18N
				alert(Ember.I18n.t("webclient.np.webalarm.addSoundFile.extnAlert")); //NO I18N
			}else if(fileObject.name.length>50) {
				alert(Ember.I18n.t("webclient.np.webalarm.addSoundFile.lengthAlert")); //NO I18N
			}else if(fileObject.size>1024000) {
				alert(Ember.I18n.t("webclient.np.webalarm.addSoundFile.sizeAlert")); //NO I18N
			}else {
				var data = new FormData();
				data.append("soundFile",fileObject); //NO I18N
				var response = opm_ajaxMultiPostRequest(window.OPM.apiUrlPattern+"/admin/saveWebAlarmSoundFile",data,false); //NO I18N
				
				if(response!==undefined) {
					if(response.error!==undefined) {
						if (response.error.errorcode==="UNMATCHED_FILE_CONTENT_TYPE") { //NO I18N
							alert(Ember.I18n.t("webclient.np.webalarm.addSoundFile.unSupportAlert")); //NO I18N
						} else if (response.error.errorcode=="PATTERN_NOT_MATCHED") { //NO I18N
							alert(Ember.I18n.t("webclient.np.webalarm.addSoundFile.charAlert")); //NO I18N
						} else {
							opm_infoMsgs("errorMsg",response.error.message); //NO I18N
						}
					}else {
						var soundList = jQuery.extend(true,[],this.model.webAlarmSoundList);
						soundList.push(response);
						this.set("model.webAlarmSoundList",soundList); //NO I18N
						this.set("model.selectedAlarmSound",response.filePath); //NO I18N
						this.set("showSoundUpload",false); //NO I18N
					}
				}
			}
		}
	},
	willDestroyElement:function(){
		$("#"+this.elementId).find("*").remove(); //NO I18N
	}
});

OPMClient.SyslogProfileTemplateConfigComponent = Ember.Component.extend({
	templateName:"syslog-profile-template-config", //NO I18N
	keyPress:function(e){
		if($(".unitValue").is(":focus")){return opm_isNumber(e);} //NO I18N
	},
	initDefaults:function() {
		if(this.model.task==="Add") { //NO I18N
			this.set("model.messageVariable","$message"); //NO I18N
		}
		if(this.model.syslogSeverityList===undefined) {
			this.set("model.syslogSeverityList",nt_getSyslogSeverityList()); //NO I18N
		}
		if(this.model.syslogFacilityList===undefined) {
			this.set("model.syslogFacilityList",nt_getSyslogFacilityList()); //NO I18N
		}
		if(this.model.sysLogSeverity===undefined) {
			this.set("model.sysLogSeverity","9"); //NO I18N
		}
		if(this.model.sysLogFacility===undefined) {
			this.set("model.sysLogFacility","0"); //NO I18N
		}
	}.on("init"), //NO I18N
	willDestroyElement:function(){
		$("#"+this.elementId).find("*").remove(); //NO I18N
	}
});

OPMClient.TrapProfileTemplateConfigComponent = Ember.Component.extend({
	templateName:"trap-profile-template-config", //NO I18N
	keyPress:function(e){
		if($(".unitValue").is(":focus")){return opm_isNumber(e);} //NO I18N
	},
	initDefaults:function() {
		var snmpVersionList = [
			{name:"v1",value:"V1"},{name:"v2C",value:"V2C"},{name:"v3",value:"V3"} //NO I18N
		];
		this.set("snmpVersionList",snmpVersionList); //NO I18N

		if(this.model.snmpVersion===undefined) {
			this.set("model.snmpVersion","V1"); //NO I18N
		}

		if(this.model.snmpv3CredentialList===undefined) {
			var response = opm_ajaxGetResponse(window.OPM.apiUrlPattern+"/admin/listCredentials?type=SNMP v3"); //NO I18N
			var v3List = (response!==undefined && response.snmpv3credential)?response.snmpv3credential:[];
			this.set("model.snmpv3CredentialList",v3List); //NO I18N
		}

		if(this.model.task==="Add") { //NO I18N
			this.set("model.messageVariable","$message"); //NO I18N
		}else if(this.model.task==="Edit" && this.model.snmpVersion!=="V3") { //NO I18N
			this.set("model.oldSnmpVersion",this.model.snmpVersion); //NO I18N
		}
		this.set("model.msgVariablePrompt",Ember.I18n.t("nfa.varbind.select.variables")); //NO I18N
	}.on("init"), //NO I18N
	didInsertElement:function() {
	},
	willDestroyElement:function(){
		$("#"+this.elementId).find("*").remove(); //NO I18N
	}
});

OPMClient.NotificationTemplateBoxComponent = Ember.Component.extend({
	templateName:"notification-template-box", //NO I18N
	profileType:"-1", //NO I18N
	prompt:Ember.I18n.t("webclient.map.flash.chooseAValue"), //NO I18N
	initDefaults:function() {
		if(this.lists===undefined) {
			this.set("lists",{}); //NO I18N
		}
		if(this.lists.All===undefined) { //NO I18N
			var jsonData = nfa_getAjaxResponse(window.OPM.apiUrlPattern+"/v2/admin/listNotificationTemplates"); //NO I18N
			var tList = (jsonData.error===undefined)?jsonData:[];
			this.set("lists.All",tList); //NO I18N
		}
		this.typeChanged();
	}.on("init"), //NO I18N
	typeChanged:function() {
		if(this.profileType!=="-1" && this.profileType!=="All" && this.lists[this.profileType]===undefined) { //NO I18N
			var tList = [];
			var allTemplates = jQuery.extend(true,[],this.lists.All);
			for(var i=0;i<allTemplates.length;i++) {
				if(allTemplates[i].profileTypeKey===this.profileType) {
					tList.push(allTemplates[i]);
				}
			}
			this.set("lists."+this.profileType,tList); //NO I18N
		}
		this.setTemplateList();
	}.observes("profileType"), //NO I18N
	setTemplateList:function(tList) {
		var tList = (this.profileType!=="-1")?jQuery.extend(true,[],this.lists[this.profileType]):[]; //NO I18N
		tList.unshift({profileName:Ember.I18n.t("jsp.commonstr.None"),templateID:"-1"}); //NO I18N
		this.set("templateList",tList); //NO I18N
	},
	willDestroyElement:function(){
		$("#"+this.elementId).find("*").remove(); //NO I18N
	}
});

function nt_listNotificationTemplates() {
	var type = $("#templateFilter").val(); //NO I18N
	var data = (type!=="All")?{profileType:type}:""; //NO I18N
	$.ajax({
		url: window.OPM.apiUrlPattern+"/v2/admin/listNotificationTemplates", //NO I18N
		data:data,
		dataType:"json", //No I18N
		type:"GET",//No I18N
		success: function(jsonData) {
			if(jsonData.error !== undefined) {
				opm_infoMsgs("errorMsg",jsonData.error.message); //NO I18N
				return;
			}
			var actionFormatter = function(cellValue,options,rowdata) {
				return "<i class='pointer icon-configedit' title='"+Ember.I18n.t('webclient.title.edit')+"' style='margin:0 7px !important;display:inline-block' onclick='nt_getNotificationTemplateActions(\"Edit\",\""+rowdata.templateID+"\",\""+rowdata.profileTypeKey+"\",\""+rowdata.profileName+"\")'></i><i class='icon-paste OpMToolTip' title='"+Ember.I18n.t("button.Copy")+"' style='margin:0 7px;cursor:Pointer;' onclick='nt_getNotificationTemplateActions(\"Copy\",\""+rowdata.templateID+"\",\""+rowdata.profileTypeKey+"\",\""+rowdata.profileName+"\")'></i><i class='icon-trash delete OpMToolTip' style='margin:0 7px;font-size:16px; cursor:pointer;' title='"+Ember.I18n.t("webclient.title.delete")+"' onclick='nt_getNotificationTemplateActions(\"Delete\",\""+rowdata.templateID+"\")'></i>"; //NO I18N
			}
			var statusFormatter = function(cellValue,options,rowdata) {
				var checkedVal = (cellValue==="true")?"checked":""; //NO I18N
				var status = (cellValue==="true")?"disable":"enable"; //NO I18N
				return "<div class='chkRoundBtn'><input type='checkbox' name='templateStatus' onclick='nt_changeNotificationTemplateStatus(\""+options.rowId+"\",\""+status+"\",this)' "+checkedVal+"><label></label></div>"; //NO I18N
			}
			var colNamesList = ["",Ember.I18n.t("jsp.commonstr.TemplateName"),Ember.I18n.t("opu.views.TYPE"),Ember.I18n.t("jsp.commonstr.Status"),Ember.I18n.t("webclient.action.actions"),"",""]; //NO I18N
			var colModelList= [
				{ name: "templateID",	index:"templateID", hidden:true}, //NO I18N
				{ name: "profileName",	index:"profileName",width:50, classes:"pointer",sorttype:"text"}, //NO I18N
				{ name: "profileType",	index:"profileType",width:30}, //NO I18N
				{ name: "status",		index:"status",		width:25, formatter:statusFormatter,search:false}, //NO I18N
				{ name: "actions",		index:"actions",	width:25, formatter:actionFormatter,search:false}, //NO I18N
				{ name: "profileTypeKey",index:"profileTypeKey", hidden:true}, //NO I18N
				{ name: "id",			index:"id",			hidden:true,sortable:false,search:false} //NO I18N
			];
			$("#nTemplateList").jqGrid("GridUnload"); //NO I18N
			var defaultOptions={sortName:"profileName",searchOption:true,toggleSearch:false,multiselect:true}; //NO I18N
			opm_loadJQgridWithData("#nTemplateList",jsonData,colNamesList,colModelList,"","nTemplatePager","NotificationTemplatesTbl",defaultOptions); //NO I18N
			$("#nTemplateList").jqGrid("setGridWidth",$(".settingsContent").width()-60); //NO I18N
			$("#nTemplateList").setGridParam({sortname:"profileName",sortorder:"asc"}).trigger("reloadGrid"); //NO I18N
		}
	});
}

function nt_getNotificationTemplateActions(task,templateID,profileType,profileName) {
	if(task==="Delete") { //NO I18N
		if(confirm(Ember.I18n.t("Field.Alert.Delete"))) { //NO I18N
			$.ajax({
				url:window.OPM.apiUrlPattern+"/v2/admin/deleteNotificationTemplate", //NO I18N
				type:"POST", //NO I18N
				data:{profileID:templateID},
				success: function(response) {
					if(response.error!==undefined){
						opm_infoMsgs("errorMsg",response.error); //NO I18N
					}else {
						opm_infoMsgs("successMsg",response.message); //NO I18N
						nt_listNotificationTemplates();
					}
				}
			});
		}
	}else {
		var type = nt_getNotificationTemplateTypeVsTypeValue(profileType);
		nt_redirectToNotificationTemplateTask(type,task,templateID);
	}
}

function nt_deleteBulkTemplates() {
	var templateIDs = nfa_getSelectedCheckBoxAsString("nTemplateList","templateID"); //NO I18N
	if(templateIDs==="") { //NO I18N
		alert(Ember.I18n.t("webclient.NotificationProfiles.selectAtleastOne")); //NO I18N
		return;
	}
	if(confirm(Ember.I18n.t("Field.Alert.Delete"))) { //NO I18N
		$.ajax({
			url:window.OPM.apiUrlPattern+"/v2/admin/deleteBulkNotificationTemplates", //NO I18N
			type:"POST", //NO I18N
			data:{profileIDs:templateIDs},
			success: function(response) {
				if(response.error!==undefined){
					opm_infoMsgs("errorMsg",(response.error.message)?response.error.message:response.error); //NO I18N
				}else {
					opm_infoMsgs("successMsg",response.message); //NO I18N
					nt_listNotificationTemplates();
				}
			}
		});
	}
}

function nt_changeNotificationTemplateStatus(rowID,status,self) {
	if(confirm(Ember.I18n.t("Field.Alert.Delete"))){ //NO I18N
		var callBackFunction=function(response){
			showMessage(response);
			nt_listNotificationTemplates();
		}
		var rowObject = $("#nTemplateList").jqGrid("getRowData",rowID); //NO I18N
		var formData = {
			profileName:rowObject.profileName,
			profileId:rowObject.templateID,
			status:status,
			isTemplate:true
		};
		nfa_postAjaxResponseWithAsync(window.OPM.apiUrlPattern+"/admin/updateNotificationProfileStatus",formData,callBackFunction); //NO I18N
	}else{
		self.checked=!(self.checked);
	}
}

function nt_getNotificationTemplateVariables(type) {
	var list = opm_ajaxGetResponse(window.OPM.apiUrlPattern+"/admin/getMailVariables",{isNotificationTemplate:true}); //NO I18N
	var variableList = (type==="RunProgram")?[]:[{group:"",name:Ember.I18n.t("webclient.admin.timeformat.default"),value:"default"}]; //NO I18N
	for(key in list) {
		for(var i=0;i<list[key].length;i++) {
			variableList.push({group:key,name:list[key][i].key,value:list[key][i].value});
		}
	}
	return variableList;
}

function nt_getCurrentTemplateDetails(model) {
	for(var i=0;i<model.templateTypes.length;i++) {
		if(model.templateTypes[i].value===model.type) {
			break;
		}
	}
	return model.templateTypes[i];
}

function removeArrayByValue(array,value) {
	var index=array.indexOf(value);
	if(index!=-1) {
		array.splice(index,1);
	}
	return array;
}

function nt_getNotificationTemplateTypes(removeHidedType) {
	var tTypes = [
		{icon:"icon icon-email",		value:"Email",		typeValue:"Send Email",		displayName:Ember.I18n.t("fwa.compliance.Email"),									title:Ember.I18n.t("opm.infoMsg.notifyprofile.email.desc")}, //NO I18N
		{icon:"icon icon-emailsms",		value:"EmailSMS",	typeValue:"Send SMS",		displayName:Ember.I18n.t("webclient.admin.smsserver.alert.emailsms"),				title:Ember.I18n.t("opm.infoMsg.notifyprofile.emailbasedsms.desc")}, //NO I18N
		{icon:"icon icon-sms",			value:"ModemSMS",	typeValue:"Send Modem SMS",	displayName:Ember.I18n.t("opmanagerclient.CN.SendSMS"),								title:Ember.I18n.t("opm.infoMsg.notifyprofile.sms.desc")}, //NO I18N
		{icon:"icon icon-chat-circle",	value:"Chat",		typeValue:"Chat",			displayName:Ember.I18n.t("webclient.notificationprofile.chat.title"),				title:Ember.I18n.t("opm.infoMsg.notifyprofile.chat.desc")}, //NO I18N
		{icon:"icon icon-runprogram",	value:"RunProgram",	typeValue:"Run Program",	displayName:Ember.I18n.t("webclient.admin.profiledetails.runprogram"),				title:Ember.I18n.t("opm.infoMsg.runProgramproperties.tooltip"),	isHide:!window.OPM.isAuthorized}, //NO I18N
		{icon:"icon icon-logticket",	value:"LogTicket",	typeValue:"Log a Ticket",	displayName:Ember.I18n.t("webclient.admin.profiledetails.LogaTicket"),				title:Ember.I18n.t("opm.infoMsg.logtkt.desc")}, //NO I18N
		{icon:"icon icon-webalarm",		value:"WebAlarm",	typeValue:"Web Alarm",		displayName:Ember.I18n.t("webclient.admin.profiledetails.WebAlarm"),				title:Ember.I18n.t("opm.inforMsg.WebAlarmproperties.tooltip"),	isHide:((window.isserver && !window.isNFAInternalCollector) || (window.isNFAInternalCollector && !nfa_isInternalCollectorSelected()))}, //NO I18N
		{icon:"icon icon-syslog",		value:"SysLog",		typeValue:"Send SysLog",	displayName:Ember.I18n.t("webclient.admin.notification.clientutil.SysLogProfile"),	title:Ember.I18n.t("webclient.admin.profiledetails.syslog.tooltip")}, //NO I18N
		{icon:"icon icon-trap",			value:"Trap",		typeValue:"Send Trap",		displayName:Ember.I18n.t("webclient.admin.notification.clientutil.TrapProfile"),	title:Ember.I18n.t("webclient.admin.profiledetails.trap.tooltip")} //NO I18N
	];

	if(removeHidedType) {
		for(var i=0;i<tTypes.length;i++) {
			if(tTypes[i].isHide){
				tTypes.splice(i,1);
				i--;
			}
		}
	}

	tTypes = nt_getTemplateLearnMoreLinks(tTypes);
	return tTypes;
}

function nt_getNotificationTemplateTypeVsTypeValue(valueToMatch) {
	var links = {
		Email:"Send Email",EmailSMS:"Send SMS",ModemSMS:"Send Modem SMS",Chat:"Chat",RunProgram:"Run Program", //NO I18N
		LogTicket:"Log a Ticket",WebAlarm:"Web Alarm",SysLog:"Send SysLog",Trap:"Send Trap" //NO I18N
	};
	var returnValue;
	for(var key in links) {
		if(links[key]===valueToMatch) {
			returnValue=key;
			break;
		}
	}
	return returnValue;
}

function nt_getSyslogSeverityList() {
	var severityList = [
		{name:"$severity",value:"9"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.debug"),		value:"7"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.information"),	value:"6"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.notice"),		value:"5"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.warning"),		value:"4"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.error"),		value:"3"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.critical"),		value:"2"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.alert"),		value:"1"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.emergency"),	value:"0"} //NO I18N
	];
	return severityList;
}

function nt_getSyslogFacilityList() {
	var facilityList = [
		{name:Ember.I18n.t("webclient.admin.syslogrules.kernel"),					value:"0"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.user"),						value:"1"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.mail"),						value:"2"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.daemon"),					value:"3"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.auth"),						value:"4"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.syslog"),					value:"5"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.lineprintersubsystem"),		value:"6"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.networknewssubsystem"),		value:"7"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.uucpsubsystem"),			value:"8"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.cron.one"),					value:"9"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.lineprintersubsystem"),		value:"6"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.networknewssubsystem"),		value:"7"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.uucpsubsystem"),			value:"8"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.cron.one"),					value:"9"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.authpriv"),					value:"10"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.ftpdaemon"),				value:"11"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.ntpsubsystem"),				value:"12"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.logaudit"),					value:"13"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.logalert"),					value:"14"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.cron.two"),					value:"15"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.localuse"),					value:"16"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.localuse.one"),				value:"17"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.localuse.two"),				value:"18"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.localuse.three"),			value:"19"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.localuse.four"),			value:"20"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.localuse.five"),			value:"21"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.localuse.six"),				value:"22"}, //NO I18N
		{name:Ember.I18n.t("webclient.admin.syslogrules.localuse.seven"),			value:"23"} //NO I18N
	];
	return facilityList;
}

function nt_getLinksByProduct() {
	var links={};
	links.emailSubjectHelpTextKey="opm.infoMsg.mail.subject.tooltip"; //NO I18N
	links.emailSubjectHelpLink="webclient.admin.notifyprofile.varibles.learnmore"; //NO I18N

	links.emailMessageHelpTextKey="opm.infoMsg.mail.subject.tooltip"; //NO I18N
	links.emailMessageHelpLink="webclient.admin.notifyprofile.varibles.learnmore"; //NO I18N

	links.smsMessageHelpTextKey="webclient.admin.profiledetails.message.tooltip"; //NO I18N
	links.smsMessageHelpLink="webclient.admin.notifyprofile.varibles.learnmore"; //NO I18N

	links.runProTitleInfoMsg=Ember.I18n.t("nfa.nTemplates.runProgram.importantNote",{productName:window.OPM.productName}); //NO I18N
	links.runProTitleInfoLink="https://www.manageengine.com/network-monitoring/script-monitoring.html"; //NO I18N
	links.runProArgumentsHelpTextKey="webclient.admin.profiledetails.cmdArgument.tooltip"; //NO I18N
	links.runProArgumentsHelpLink="webclient.admin.notifyprofile.varibles.learnmore"; //NO I18N

	links.sysLogMessageHelpTextKey="webclient.admin.profile.msgvariable.tooltip"; //NO I18N
	links.sysLogMessageHelpLink="webclient.admin.notifyprofile.varibles.learnmore"; //NO I18N

	links.trapProMessageHelpTextKey="webclient.admin.profile.varbind.tooltip"; //NO I18N
	links.trapProMessageHelpLink="https://www.manageengine.com/network-monitoring/faq/what-is-varbind.html"; //NO I18N

	return links;
}

function nt_getTemplateLearnMoreLinks(tTypes) {
	var links = {
		Email:"",EmailSMS:"",ModemSMS:"",Chat:"",LogTicket:"", //NO I18N
		RunProgram:"https://www.manageengine.com/network-monitoring/help/run-program.html", //NO I18N
		WebAlarm:"https://www.manageengine.com/network-monitoring/help/configure-web-alarm-profile.html", //NO I18N
		SysLog:"https://www.manageengine.com/network-monitoring/help/syslog-profile.html", //NO I18N
		Trap:"https://www.manageengine.com/network-monitoring/help/trap-profile.html" //NO I18N
	}
	for(var i=0;i<tTypes.length;i++) {
		tTypes[i].learnMoreLink = links[tTypes[i].value];
	}
	return tTypes;
}

function validateNotificationTemplate(model) {
	var fields = {empty:["templateName"],custom:[{"identifier":"templateName","condition":!nfa_isValidName(model.templateName,"~!@#$%^&*+=()[]\/\\\';,{}|\":<>?`."),"message":Ember.I18n.t("webclient.admin.traps.specialchar")}]}; //NO I18N
	if(!opm_validateFields(fields)) {
		return false;
	}
	switch(model.type) {
		case "Email": 		//NO I18N
		case "EmailSMS": 	if(!OPMClient.SettingsAddEditController.isMailServerConfigured) { //NO I18N
								alert(Ember.I18n.t("webclient.reports.nomailserver.notauth.click")); //NO I18N
								return false;
							}
							fields.empty = ["fromAddress","toAddress"]; //NO I18N
							fields.emailValidation = ["fromAddress","toAddress"]; //NO I18N
							if(!model.hideEmailCCLink) {
								fields.empty.push("ccAddress"); //NO I18N
								fields.emailValidation.push("ccAddress"); //NO I18N
							}
							break;
		case "ModemSMS":	fields.empty.push("toNumber"); //NO I18N
							break;
		case "Chat":		if(model.receiverType==="channel") { //NO I18N
								fields.empty.push("slackChannelList"); //NO I18N
							}else {
								fields.empty.push("slackUserList"); //NO I18N
							}
							break;
		case "RunProgram":	fields.empty.push("runProgramCommand"); //NO I18N
							break;
		case "LogTicket":	if(!model[model.serviceType+"Enabled"]) { //NO I18N
								opm_infoMsgs("infoMsg",Ember.I18n.t("opm.infoMsg.logTicket."+model.serviceType+".tooltip")); //NO I18N
								return;
							}
							break;
		case "WebAlarm":	if(model.selectedUsers.length>0 || model.adminOption==="-1" || model.operatorOption==="-2" || (window.OPM.isNFA && model.guestOption==="-3")) { //NO I18N
								fields.empty.push("soundFiles"); //NO I18N
							}else {
								alert(Ember.I18n.t("webclient.dashboard.useralert")); //NO I18N
								return;
							}
							break;
		case "SysLog":		fields.empty = ["sysLogHost","sysLogPort","sysLogSeverity","sysLogFacility"]; //NO I18N
							fields.port = ["sysLogPort"]; //NO I18N
							break;
		case "Trap":		fields.empty = ["peerName","trapPort"]; //NO I18N
							if(model.snmpVersion==="V3") {
								fields.empty.push("snmpv3Credential");
							}else if(model.task!=="Edit" || model.oldSnmpVersion!==model.snmpVersion) { //NO I18N
								fields.empty.push("trapCommunity"); //NO I18N
							}
							fields.port = ["trapPort"]; //NO I18N
							break;

	}
	if(["Email","EmailSMS","Chat","LogTicket"].contains(model.type)) { //NO I18N
		fields.empty.push("subjectVariable"); //NO I18N
		fields.empty.push("messageVariable"); //NO I18N
	}
	if(["ModemSMS","SysLog","Trap"].contains(model.type)) { //NO I18N
		fields.empty.push("messageVariable"); //NO I18N
	}
	return opm_validateFields(fields);
}

function saveNotificationTemplate(model,isTesting) {
	var formData={
		name:model.templateName,
		profileType:model.template.typeValue,
		templateType:(window.OPM.isNFA)?"NFA":(window.OPM.isFWA)?"FWA":"OPM" //NO I18N
	};
	switch(model.type) {
		case "Email": 		//NO I18N
		case "EmailSMS": 	formData.fromAddress=model.fromAddress; //NO I18N
							formData.toAddress=model.toAddress;
							if(model.type==="Email") { //NO I18N
								if(!model.hideEmailCCLink) {
									formData.ccAddress=model.ccAddress;
								}
								formData.MAILFORMAT=model.mailFormat;
							}
							formData.server=OPMClient.SettingsAddEditController.mailServerSettings.primary.mailservername;
							formData.portNumber=OPMClient.SettingsAddEditController.mailServerSettings.primary.mailserverport;
							break;
		case "ModemSMS":	formData.gateway=model.smsGatewaysVsID[model.selectedGateWay]; //NO I18N
							formData.toNumber=model.toNumber;
							formData.clickatellSet=model.smsGatewayConfig.Clickatell;
							formData.serialmodemSet=model.smsGatewayConfig.serialmodem;
							formData.customSet=model.smsGatewayConfig.custom;
							formData.smppSet=model.smsGatewayConfig.SMPP;
							formData.appSMSSet=model.smsGatewayConfig.SMSEagle;
							formData.message=model.messageVariable;
							break;
		case "Chat":		formData.ischannel=(model.receiverType==="channel"); //NO I18N
							if(formData.ischannel) {
								formData.receiverid=model.slackChannelID;
							}else {
								formData.receiverid=model.slackMemberID;
							}
							formData.productName="SLACK"; //NO I18N
							break;
		case "RunProgram":	formData.sysprogram=model.runProgramCommand; //NO I18N
							formData.sysarguments=model.messageVariable;
							formData.errappend=model.errappend;
							formData.append=model.append;
							break;
		case "LogTicket":	formData=jQuery.extend(true,{},formData,model[model.serviceType+"Ticket"]); //NO I18N
							formData.productName=model.serviceType.toUpperCase();
							// if(model.serviceType==="serviceNow") { //NO I18N
							// 	formData.ticketItem = $("#logTicketList .ticketItemList").val(); //NO I18N
							// }
							break;
		case "WebAlarm": 	if(model.adminOption==="-1") {model.selectedUsers.push("-1");} //NO I18N
							if(model.operatorOption==="-2") {model.selectedUsers.push("-2");} //NO I18N
							if(window.OPM.isNFA && model.guestOption==="-3") { //NO I18N
								model.selectedUsers.push("-3"); //NO I18N
							}
							formData.userNames=model.selectedUsers.join(","); //NO I18N
							formData.soundFile=model.selectedAlarmSound;
							break;
		case "SysLog":		formData.sysLogHost=model.sysLogHost; //NO I18N
							formData.sysLogPort=model.sysLogPort;
							formData.severity=model.sysLogSeverity;
							formData.facility=model.sysLogFacility;
							formData.variables=model.messageVariable;
							break;
		case "Trap":		formData.peername=model.trapProfilePeerName; //NO I18N
							formData.trap_port=model.trapProfilePort;
							formData.version=model.snmpVersion;
							if(model.snmpVersion==="V3") { //NO I18N
								formData.credentialId=model.snmpv3CredentialID;
								formData.community=""; //NO I18N
							}else if(model.task!=="Edit" || model.oldSnmpVersion!==model.snmpVersion) { //NO I18N
								formData.community=model.trapCommunity;
							}
							formData.varbind=model.messageVariable;
							break;
	}
	if(["Email","EmailSMS","Chat","LogTicket"].contains(model.type)) { //NO I18N
		formData.subject=model.subjectVariable;
		formData.message=model.messageVariable;
	}

	var callBackFunction = function(response) {
		if(response.error!==undefined) {
			opm_infoMsgs("errorMsg",(response.error.message)?response.error.message:response.error); //NO I18N
		}else {
			if(isTesting) {
				opm_infoMsgs("successMsg",response.result.message); //NO I18N
			}else {
				nt_redirectToNotificationTemplateList();
				opm_infoMsgs("successMsg",response.message); //NO I18N
			}
		}
	};

	var apiURL;
	if(isTesting) {
		if(model.type==="WebAlarm") { //NO I18N
			playSoundForWebAlarm({"entity":"true","soundFile":formData.soundFile}); //NO I18N
		}else {
			apiURL = window.OPM.apiUrlPattern+"/v2/admin/testNotificationTemplate"; //NO I18N
			nfa_postAjaxResponseWithAsync(apiURL,formData,callBackFunction);
		}
	}else {
		if(!nf_checkTemplateNameIsExist(model)) {
			if(model.task==="Edit") { //NO I18N
				formData.profileID=model.templateID;
				apiURL = window.OPM.apiUrlPattern+"/v2/admin/updateNotificationTemplate"; //NO I18N
			}else {
				apiURL = window.OPM.apiUrlPattern+"/v2/admin/addNotificationTemplate"; //NO I18N
			}
			nfa_postAjaxResponseWithAsync(apiURL,formData,callBackFunction);
		}
	}
}

function nf_checkTemplateNameIsExist(model) {
	var flag = false;
	if(model.templateName_old!==model.templateName) {
		var jsonData = nfa_getAjaxResponse(window.OPM.apiUrlPattern+"/admin/checkNProfile",{name:model.templateName}); //NO I18N
		if(jsonData!==null && jsonData!==undefined && jsonData.error!==undefined) {
			opm_infoMsgs("errorMsg",jsonData.error.message); //NO I18N
			flag = true;
		}
	}
	return flag;
}

function nt_getNotificationTemplateModel(model) {
	model.pageName = "addPage"; //NO I18N
	model.hidePage = nt_isHidepage();
	model.templateTypes = nt_getNotificationTemplateTypes();
	model.template = nt_getCurrentTemplateDetails(model);
	model.variableList = nt_getNotificationTemplateVariables(model.type);
	model.subVariablePrompt = Ember.I18n.t("webclient.admin.profiledetails.subject.SelectValue"); //NO I18N
	model.msgVariablePrompt = Ember.I18n.t("webclient.admin.profiledetails.message.SelectValue"); //NO I18N
	model.serviceDeskTicket = {};
	model.serviceNowTicket = {};
	model.templateName = ""; //NO I18N

	if(model.task!=="Add") { //NO I18N
		var response = nfa_getAjaxResponse(window.OPM.apiUrlPattern+"/v2/admin/getNotificationTemplate",{profileID:model.templateID}); //NO I18N
		if(response.error!==undefined) {
			if(window.OPM.isNFA) {
				opmGlobalRoute.transitionTo("Settings.NetflowConfig.NotificationTemplates"); //NO I18N
			}else if(window.OPM.isFWA) {
				opmGlobalRoute.transitionTo("Settings.FirewallConfig.NotificationTemplates"); //NO I18N
			}
			opm_infoMsgs("errorMsg",response.error.message); //NO I18N
			return;
		}
		if(model.task==="Edit") { //NO I18N
			model.templateName = response.name;
			model.templateName_old = response.name;
		}

		switch(model.type) {
			case "Email": 		//NO I18N
			case "EmailSMS": 	model.fromAddress = response.fromAddress; //NO I18N
								model.toAddress = response.toAddress;
								if(model.type==="Email") { //NO I18N
									model.ccAddress = response.ccAddress;
									model.mailFormat = response.MAILFORMAT;
								}
								break;
			case "ModemSMS":	model.selectedGateWay = response.gateway; //NO I18N
								model.toNumber = response.toNumber;
								model.messageVariable = response.message;
								break;
			case "Chat":		model.receiverType = response.receivertype; //NO I18N
								if(model.receiverType==="channel") { //NO I18N
									model.slackChannelID = response.receiverid;
								}else {
									model.slackUserID = response.receiverid;
									model.slackMemberID = response.receiverid;
								}
								model.productName=response.productName;
								break;
			case "RunProgram":	model.runProgramCommand = response.sysprogram; //NO I18N
								model.messageVariable = response.sysarguments;
								model.errappend = (response.errappend==="true"); //NO I18N
								model.append = (response.append==="true"); //NO I18N
								model.timeout = response.timeout;
								break;
			case "LogTicket":	var ticket = { //NO I18N
									ticketCategory:response.ticketCategory,
									ticketGrpTech:response.ticketGrpTech,
									ticketItem:response.ticketItem,
									ticketPriority:response.ticketPriority,
									ticketSubCategory:response.ticketSubCategory,
									ticketTechnician:response.ticketTechnician
								}
								if(response.productName==="SERVICEDESK") { //NO I18N
									model.serviceType="serviceDesk"; //NO I18N
									model.serviceDeskTicket = ticket;
								}else {
									model.serviceType="serviceNow"; //NO I18N
									model.serviceNowTicket = ticket;
									//model.itemName = response.itemName;
								}
								break;
			case "WebAlarm": 	model.selectedUsers = response.userNames; //NO I18N
								if(model.selectedUsers.contains("-1")) { //NO I18N
									model.adminOption="-1"; //NO I18N
									model.selectedUsers = removeArrayByValue(model.selectedUsers,"-1"); //NO I18N
								}
								if(model.selectedUsers.contains("-2")) { //NO I18N
									model.operatorOption="-2"; //NO I18N
									model.selectedUsers = removeArrayByValue(model.selectedUsers,"-2"); //NO I18N
								}
								if(model.selectedUsers.contains("-3")) { //NO I18N
									model.guestOption="-3"; //NO I18N
									model.selectedUsers = removeArrayByValue(model.selectedUsers,"-3"); //NO I18N
								}
								model.selectedAlarmSound = response.soundFile;
								break;
			case "SysLog":		model.sysLogHost = response.sysLogHost; //NO I18N
								model.sysLogPort = response.sysLogPort;
								model.sysLogSeverity = response.severity;
								model.sysLogFacility = response.facility;
								model.messageVariable = response.variables;
								break;
			case "Trap":		model.trapProfilePeerName = response.peername; //NO I18N
								model.trapProfilePort = response.trap_port;
								model.snmpVersion = response.version;
								if(model.snmpVersion==="V3") { //NO I18N
									model.snmpv3CredentialID = response.credentialId;
									model.trapCommunity = ""; //NO I18N
								}else {
									model.trapCommunity = response.community;
								}
								model.messageVariable = response.varbind;
								break;

		}
		if(["Email","EmailSMS","Chat","LogTicket"].contains(model.type)) { //NO I18N
			model.subjectVariable = response.subject;
			model.messageVariable = response.message;
		}
	}else {
		model.subjectVariable = nt_getDefaultSubjectVariables();
		model.messageVariable = nt_getDefaultMessageVariables();
	}
	model.links = nt_getLinksByProduct();
	return model;
}

function nt_getDefaultSubjectVariables() {
	var subVariable;
	if(window.OPM.isOPM) {
		subVariable = Ember.I18n.t("webclient.mail.subject.model"); //NO I18N
	}else if(window.OPM.isNFA) {
		subVariable = Ember.I18n.t("nfa.nTemplates.defaultSubject.variable"); //NO I18N
	}else if(window.OPM.isFWA) {
		subVariable = Ember.I18n.t("webclient.fwa.notificationTemp.defaultSubject"); //NO I18N
	}
	return subVariable;
}

function nt_getDefaultMessageVariables() {
	var msgVariable;
	if(window.OPM.isOPM) {
		msgVariable = Ember.I18n.t("webclient.mail.message.model"); //NO I18N
	}else if(window.OPM.isNFA) {
		msgVariable = Ember.I18n.t("nfa.nTemplates.defaultMessage.variable"); //NO I18N
	}else if(window.OPM.isFWA) {
		msgVariable = Ember.I18n.t("webclient.fwa.notificationTemp.defaultMsg"); //NO I18N
	}
	return msgVariable;
}

function nt_redirectToNotificationTemplateTask(type,task,templateID) {
	var routeName;
	if(window.OPM.isOPM) {
		routeName = "Settings.Notification.TemplateTask"; //NO I18N
	}else if(window.OPM.isNFA) {
		routeName = "Settings.NetflowConfig.NotificationTemplateTask"; //NO I18N
	}else if(window.OPM.isFWA) {
		routeName = "Settings.FirewallConfig.NotificationTemplateTask"; //NO I18N
	}
	opmGlobalRoute.transitionTo(routeName,{type:type,task:task,templateID:templateID});
}

function nt_redirectToNotificationTemplateTypes() {
	if(window.OPM.isOPM) {
		opmGlobalRoute.transitionTo("Settings.Notification.TemplateTypes"); //NO I18N
	}else if(window.OPM.isNFA) {
		opmGlobalRoute.transitionTo("Settings.NetflowConfig.NotificationTemplateTypes"); //NO I18N
	}else if(window.OPM.isFWA) {
		opmGlobalRoute.transitionTo("Settings.FirewallConfig.NotificationTemplateTypes"); //NO I18N
	}
}

function nt_redirectToNotificationTemplateList() {
	if(window.OPM.isOPM) {
		opmGlobalRoute.transitionTo("Settings.Notification.TemplateList"); //NO I18N
	}else if(window.OPM.isNFA) {
		opmGlobalRoute.transitionTo("Settings.NetflowConfig.NotificationTemplateList"); //NO I18N
	}else if(window.OPM.isFWA) {
		opmGlobalRoute.transitionTo("Settings.FirewallConfig.NotificationTemplateList"); //NO I18N
	}
}

function nt_getTemplateTaskCallBackURL(type,task,templateID) {
	if(window.OPM.isOPM) {
		return "/Settings/Notification/Templates/"+type+"/"+task+"/"+templateID; //NO I18N
	}else if(window.OPM.isNFA) {
		return "/Settings/NetflowConfig/NotificationTemplates/"+type+"/"+task+"/"+templateID; //NO I18N
	}else if(window.OPM.isFWA) {
		return "/Settings/FirewallConfig/NotificationTemplates/"+type+"/"+task+"/"+templateID; //NO I18N
	}
	return ""; //NO I18N
}

function nt_isHidepage() {
	return (window.isNFAGuest || window.OPM.isCustomer || !(window.OPM.isNFA || window.OPM.isFWA || window.OPM.isOPM));
}
